;*********  -    ***********
;  U 
.NOLIST
.include "tn15def.inc"
.LIST
;******************   *******************

; Up= Step1*K1*NU -   PB2
; Step1= Uop/1024 = 2560/1024 = 5/2 mv/
; K1= KU/1000 -   U  PB2
; NU - - ADC
; Up= (5*KU*NU)/(2*1000)= (KU*NU)/(2*200)

; Um= Step2*K2*NI -   PB3
; Step2= Uop/(1024*20) = 2560/1024 = 1/8 mv/
; K2= KI/1000 -   I  PB3 Kg<=13
; NI - - ADC
; Um= (KI*NI)/(8*1000)= (KI*NI)/(64*125)

; Ub= Up-Um*KK -  .
; KK -    

; I= Um/R - 
; R= RU/10000, RU = mv/10a
; I= [(KI*NI)/(64*125)]/(RU/10000)= (KI*NI*10000)/(64*125*RU)

; I= (5*KI*NI)/(4*RU)
;************************************************************
;    
        .eseg
        .org   0x39

KK:     .db  1      ;     (1...255)
KU:     .dw  10990  ; (*1000<=65000)  U  PB2 (1/10)
KI:     .dw  1024   ; (*1000<=13000)  U  PB3 (1/1)
RU:     .db  100    ;      10, 
CALIBR: .db  0x8E   ;  

; 
; PB0   - SK  
; PB1   - DI  /
; PB2   - ADC U
; PB3   - ADC I+
; PB4   - ADC I-
; PB5   - RST
;  
.equ  SK   =PB0     ; SK 
.equ  DI   =PB1     ; DI 

;  
.def  ARGA2    =R0
.def  ARGB5    =R0

.def  ARGA1    =R1
.def  ARGB4    =R1
.def  ARGD9    =R1
.equ  ADR_ARGD9=1   ;  R1

.def  ARGA0    =R2
.def  ARGB3    =R2
.def  ARGD8    =R2

.def  ARGB2    =R3
.def  ARGD7    =R3

.def  ARGB1    =R4
.def  ARGD6    =R4

.def  ARGB0    =R5
.def  ARGD5    =R5

.def  ARGC2    =R6
.def  ARGD4    =R6

.def  ARGC1    =R7
.def  ARGD3    =R7

.def  ARGC0    =R8
.def  ARGD2    =R8

.def  ARGD1    =R9

.def  ARGD0    =R10
.equ  ADR_ARGD0=10  ;  R10

.def  ADCIHi   =R11
.def  ARGE4    =R11

.def  ADCILow  =R12
.def  ARGE3    =R12

.def  ADCUHi   =R13
.def  ARGE2    =R13

.def  ADCULow  =R14
.def  ARGE1    =R14

.def  ARGE0    =R15
.def  CNTIzm   =R15

.def  TMP1     =R16
.def  TMP2     =R17
.def  COUNT1   =R18
.def  FLAG     =R19

.def  IHi      =R20
.def  ILow     =R21
.def  UHi      =R22
.def  ULow     =R23

.def  SumIUp   =R24
.def  SumIHi   =R25
.def  SumILow  =R26
.def  SumUUp   =R27
.def  SumUHi   =R28
.def  SumULow  =R29

;  FLAG
.equ  BIT_OVFI =0  ; =1 -  I
.equ  BIT_OVFU =1  ; =1 -  U

;   ADC
; 1  ADC = 130mcs (100khz)
.equ  Nizm    =154 ; 20000/130=~154,  20ms -  U, I

          .cseg 
          .org  $0000

          nop
          nop       ;  
          nop       ; /
          nop       ; /
          nop       ; /
          nop       ; /
          nop       ; /
          nop       ; /
          nop       ; /
; 
          cli               ; .  .
          ldi   TMP1,$0F
          out   WDTCR,TMP1  ; . WDT  2
          wdr               ;  WDT
          clr   TMP1
          out   MCUSR,TMP1  ;   RESET
          out   GIMSK,TMP1  ;   .
          out   TIMSK,TMP1  ;  . 
          out   TCCR0,TMP1  ;  TMR0
          out   TCCR1,TMP1  ;  TMR1
          out   SFIOR,TMP1
          out   EECR,TMP1   ;  EEPROM
          ldi   TMP1,$60    ; SLEEP -  IDL, . .
          out   MCUCR,TMP1
          ldi   TMP1,CALIBR ;  . 
          rcall READEE
          cpi   TMP2,$FF
          brne  PC+2        ; < FF
          ldi   TMP2,0x80   ;   
          out   OSCCAL,TMP2 ; . 
          ldi   TMP1,$80
          out   ACSR,TMP1   ; . 
          clr   TMP1
          out   PORTB,TMP1  ; PORTB=0
          ldi   TMP1,$03    ; 0000.0011
          out   DDRB,TMP1   ; PB0,1-OUT
          ldi   COUNT1,20
          rcall ZADN        ; 2 sec  .

; *************   ***************
CIKL:     ldi   TMP1,16     ; -  
          mov   CNTIzm,TMP1
          clr   SumIUp
          clr   SumIHi
          clr   SumILow
          clr   SumUUp
          clr   SumUHi
          clr   SumULow
CIKL1:    rcall Mesure      ; 
          rcall CntUI       ; 
          add   SumILow,ILow
          adc   SumIHi,IHi
          brcc  PC+2
          inc   SumIUp
          add   SumULow,ULow
          adc   SumUHi,UHi
          brcc  PC+2
          inc   SumUUp
          wdr
          dec   CNTIzm
          brne  CIKL1        ; 8 
; /8
          ldi   TMP1,4       ; - 
CIKL2:    lsr   SumIUp
          ror   SumIHi
          ror   SumILow
          lsr   SumUUp
          ror   SumUHi
          ror   SumULow
          dec   TMP1
          brne  CIKL2        ; 4 , /16
; 
          mov   IHi,SumIHi
          mov   ILow,SumILow
          mov   UHi,SumUHi
          mov   ULow,SumULow
; I
          mov   ARGB1,IHi   ; I
          mov   ARGB0,ILow
          rcall TRN10       ; 2-10
;  00  0A    I
          ldi   TMP1,$0A
          mov   ARGE3,ARGD4 ;  .  I
          tst   ARGD3
          brne  PC+2        ; <>0
          mov   ARGD3,TMP1
          mov   ARGE2,ARGD3 ;  I
          tst   ARGD2
          brne  PC+2        ; <>0
          mov   ARGD2,TMP1
          mov   ARGE1,ARGD2 ;  I
          tst   ARGD1
          brne  PC+2        ; <>0
          mov   ARGD1,TMP1
          mov   ARGE0,ARGD1 ;  I
; U
          mov   ARGB1,UHi   ; U
          mov   ARGB0,ULow
          rcall TRN10       ; 2-10
;  00  0A    
          ldi   TMP1,$0A
          tst   ARGD4
          brne  PC+2        ; <>0
          mov   ARGD4,TMP1
          mov   ARGD9,ARGD4 ; U
          tst   ARGD3
          brne  PC+2        ; <>0
          mov   ARGD3,TMP1
          mov   ARGD8,ARGD3 ; U
          tst   ARGD2
          brne  PC+2        ; <>0
          mov   ARGD2,TMP1
          mov   ARGD7,ARGD2 ; U
          tst   ARGD1
          brne  PC+2        ; <>0
          mov   ARGD1,TMP1
          mov   ARGD6,ARGD1 ; U
          clr   ARGD5
          clr   ARGD4
;  I  
          mov   ARGD3,ARGE3
          mov   ARGD2,ARGE2
          mov   ARGD1,ARGE1
          mov   ARGD0,ARGE0
;  
          ldi   TMP1,$0F    ; -
          sbrs  FLAG,BIT_OVFU
          rjmp  OverI       ;   U
          mov   ARGD9,TMP1
          mov   ARGD8,TMP1
          mov   ARGD7,TMP1
          mov   ARGD6,TMP1
OverI:    sbrs  FLAG,BIT_OVFI
          rjmp  OutIN       ;   I
          clr   ARGD3
          mov   ARGD2,TMP1
          mov   ARGD1,TMP1
          mov   ARGD0,TMP1
OutIN:    rcall INDIC       ;  
          rjmp  CIKL        ;  

;*******************************************************
;******************** / ******************************

;  READ EEPROM
; :  TMP1 - 
; : TMP2 - 

READEE:   out   EEAR,TMP1   ;  EEPROM
          sbi   EECR,EERE   ;   EERE -> 
          in    TMP2,EEDR   ;    EEPROM -> TMP2
          ret

; /  N*0,1cek
; : COUNT1=N
; . TMP1,TMP2
ZADN:     ldi   TMP1,90     ; . 0,1cek
          clr   TMP2        ; . 1ms
ZAD001:   dec   TMP2
          rjmp  PC+1
          rjmp  PC+1
          brne  ZAD001      ; ~1ms
          wdr               ;  WDT
          dec   TMP1
          brne  ZAD001      ; ~100ms
          dec   COUNT1
          brne  ZADN       ; ~N*0,1s
          ret

; /  I  U
; : ADCIHi,ADCILow - ADC -  
;        ADCUHi,ADCULow - ADC -  
;        FLAG,BIT_OVFI =1 -  I
;        FLAG,BIT_OVFU =1 -  U
; : ARGA2,ARGA1,ARGA0 (ARGB5...ARGB3)
;               ARGB2,ARGB1,ARGB0
;               ARGC2,ARGC1,ARGC0
;               ARGD1,ARGD0
;               TMP1,TMP2,COUNT1
;    2  
Mesure:
;   0  I
            ldi   TMP1,$85    ; 1000.0101 IntVref,right,PB3-PB3,*20
            out   ADMUX,TMP1
            ldi   TMP1,$D4    ; 1101.0100 ADC inable,start,once,intdisable
            out   ADCSR,TMP1  ; 1/16=100khz
            sbis  ADCSR,ADIF  ; ADC end
            rjmp  PC-1        ;   ADC
            in    ARGD0,ADCL  ; Offset 0
;  ADC  . I
            ldi   TMP1,$87    ; 1000.0111 IntVref,right,PB3-PB4,*20
            out   ADMUX,TMP1
            ldi   TMP1,$F4    ; 1111.0100 ADC inable,start,free,intdisable
            out   ADCSR,TMP1  ; 1/16=100khz
;   I
            clt               ; T=0
            ldi   COUNT1,Nizm ; - 
            clr   ARGB0       ;  - 
            clr   ARGB1       ; /
            clr   ARGB2       ; /
            clr   ARGA2       ; .. ADC 
DJ1:        rcall ADCWt       ; ADC
            rcall SubOff      ; - Offset
            add   ARGB0,ARGA0
            adc   ARGB1,ARGA1
            adc   ARGB2,ARGA2
            tst   COUNT1
            brne  DJ1         ;  Nizm 
            clr   TMP1
            out   ADCSR,TMP1  ;  ADC
            bld   FLAG,BIT_OVFI ;   
; ARGB2...ARGB0 -  .  I
;  ADC  . U
            ldi   TMP1,$81    ; 1000.0001 IntVref,right,PB2
            out   ADMUX,TMP1
            ldi   TMP1,$F4    ; 1111.0100 ADC inable,start,free,intdisable
            out   ADCSR,TMP1  ; 1/16=100khz
;  U
            clt               ; T=0
            ldi   COUNT1,Nizm ; - 
            clr   ARGC0       ;  - 
            clr   ARGC1       ; /
            clr   ARGC2       ; /
            clr   ARGA2       ; .. ADC U
DU1:        rcall ADCWt
            add   ARGC0,ARGA0
            adc   ARGC1,ARGA1
            adc   ARGC2,ARGA2
            tst   COUNT1
            brne  DU1
            clr   TMP1
            out   ADCSR,TMP1  ;  ADC
            bld   FLAG,BIT_OVFU ;   
; ARGC2...ARGC0 -  .  U
;  I ADC: (ARGB2...ARGB0)/ARGD0-->ADCIHi,ADCILow
            clr   ARGB3       ; .. 
            ldi   COUNT1,Nizm ; - 
            mov   ARGB5,COUNT1; 
            rcall DL41
            mov   ADCIHi,ARGB1  ; 
            mov   ADCILow,ARGB0 ; /
;  U ADC: (ARGC2...ARGC0)/ARGD1-->ADCUHi,ADCULow
            mov   ARGB0,ARGC0
            mov   ARGB1,ARGC1
            mov   ARGB2,ARGC2
            clr   ARGB3       ; .. 
            ldi   COUNT1,Nizm ; - 
            mov   ARGB5,COUNT1; 
            rcall DL41
            mov   ADCUHi,ARGB1  ; 
            mov   ADCULow,ARGB0 ; /
            ret

; /  ADC
; : ARGA1,ARGA0
;        T=1 - >=3F0
; : TMP2
ADCWt:      dec   COUNT1
            sbis  ADCSR,ADIF  ;   ADC
            rjmp  PC-1
            sbi   ADCSR,ADIF  ;  ,  
            in    ARGA0,ADCL  ; 
            in    ARGA1,ADCH  ; /
            mov   TMP2,ARGA0
            subi  TMP2,$F0    ; ARGA0-F0
            brcs  ADCWEnd     ; ARGA0<F0
            mov   TMP2,ARGA1
            subi  TMP2,03
            brne  ADCWEnd     ; ARGA1 <>3
            set               ; T=1, 3FF - 
ADCWEnd:    ret

; /   0
; :  ARGA1,ARGA0
;        ARGD0 - 
; : ARGA1,ARGA0
; : ARGD1
SubOff:     clr   ARGD1
            sub   ARGA0,ARGD0
            sbc   ARGA1,ARGD1
            brcc  Sbf1        ;  
            clr   ARGA0       ; ,  =0
            clr   ARGA1
Sbf1:       ret

; /  4-    1 
; :  ARGB3-ARGB0 -    :  ARGB3-ARGB0 - 
;                                         
;              ARGB5 -                 ARGB4 - 
; . COUNT1 - . 

DL41:       ldi   COUNT1,$20  ; - 
            clr   ARGB4       ;  .  
DEL3:       rol   ARGB0       ;    
            rol   ARGB1
            rol   ARGB2
            rol   ARGB3
            rol   ARGB4
            brcc  DEL1
            sub   ARGB4,ARGB5 ; ARGB4,ARGB5-->ARGB4
            sec               ; 1-->C
            rjmp  DEL2
DEL1:       cp    ARGB4,ARGB5 ; ARGB4-ARGB5
            brcs  DEL4
            sub   ARGB4,ARGB5 ; ARGB4-ARGB5-->ARGB4
            sec               ; C=1
            rjmp  DEL2
DEL4:       clc               ; C=0
DEL2:       dec   COUNT1
            brne  DEL3        ;  32 
            rol   ARGB0
            rol   ARGB1
            rol   ARGB2
            rol   ARGB3
            ret

; /  2-  
; :  ARGB5,ARGB4 - 1 
;        ARGB1,ARGB0 - 2 
; : ARGB3...ARGB0
; : COUNT1

MUL16:      clr   ARGB3       ; clear 2 highest bytes of result
            clr   ARGB2
            ldi   COUNT1,16   ; init loop counter
            lsr   ARGB1
            ror   ARGB0
M16u_1:     brcc  Noad8       ; if bit 0 of multiplier set
            add   ARGB2,ARGB4 ; add multiplicand Low to byte 2 of res
            adc   ARGB3,ARGB5 ; add multiplicand high to byte 3 of res
Noad8:      ror   ARGB3       ; shift right result byte 3
            ror   ARGB2       ; rotate right result byte 2
            ror   ARGB1       ; rotate result byte 1 and multiplier High
            ror   ARGB0       ; rotate result byte 0 and multiplier Low
            dec   COUNT1      ; decrement loop counter
            brne  M16u_1      ; if not done, loop more
            ret

; /  I  U
; Up= (KU*NU)/(2*200)
; Um= (KI*NI)/(64*125)
; Ub= Up-Um*KK -  ., mv
; I= (5*KI*NI)/(4*RU) - , ma

; :  ADCIHi,ADCILow =NI - ADC -  
;        ADCUHi,ADCULow =NU - ADC -  
; : IHi,Ilow - , 
;        UHi,ULow - , 
; : ARGB5...ARGB0,ARGD1,ARGD0,COUNT1
CntUI:
;  KU
         ldi   TMP1,KU      ;  KU
         rcall READEE
         mov   ARGB0,TMP2   ; low KU
         inc   TMP1
         rcall READEE
         mov   ARGB1,TMP2   ; hi KU
         cpi   TMP2,$FF
         brne  CntUI02      ; (hi KU) < FF
         ldi   TMP2,high (11000) ;   
         mov   ARGB1,TMP2
         ldi   TMP2,low (11000)
         mov   ARGB0,TMP2
;  Up
CntUI02: mov   ARGB4,ADCULow; low NU
         mov   ARGB5,ADCUHi ; hi NU
         rcall MUL16        ; (KU*NU)-->ARGB3...ARGB0
         ldi   COUNT1,2
         mov   ARGB5,COUNT1
         rcall DL41         ; /2
         ldi   COUNT1,200
         mov   ARGB5,COUNT1
         rcall DL41         ; /200
         mov   UHi,ARGB1    ;  U
         mov   ULow,ARGB0   ; /
;  KI
         ldi   TMP1,KI      ;  KI
         rcall READEE
         mov   ARGB0,TMP2   ; low KI
         mov   ARGD0,TMP2   ; /
         inc   TMP1
         rcall READEE
         mov   ARGB1,TMP2   ; hi KI
         mov   ARGD1,TMP2   ; /
         cpi   TMP2,$FF
         brne  CntUI03      ; (hi KI) < FF
         ldi   TMP2,high (1000) ;   
         mov   ARGB1,TMP2
         mov   ARGD1,TMP2   ; /
         ldi   TMP2,low (1000)
         mov   ARGB0,TMP2
         mov   ARGD0,TMP2   ; /
;  Um
CntUI03: mov   ARGB4,ADCILow; low NI
         mov   ARGB5,ADCIHi ; hi NI
         rcall MUL16        ; (KI*NI)-->ARGB3...ARGB0
         ldi   COUNT1,64
         mov   ARGB5,COUNT1
         rcall DL41         ; /64
         ldi   COUNT1,125
         mov   ARGB5,COUNT1
         rcall DL41         ; /125
; Um*KK
         ldi   TMP1,KK      ;  KK
         rcall READEE
         cpi   TMP2,$FF
         brne  PC+2         ; KK < FF
         ldi   TMP2,5       ;   KK=5
         mov   ARGB4,TMP2   ; low KK
         clr   ARGB5        ; hi KK
         rcall MUL16        ; [(KI*NI)/(64*125)]*KK-->ARGB3...ARGB0
         or    ARGB3,ARGB2
         breq  CntUI01      ; ARGB3=ARGB2=0
         clr   ARGB1        ; ARGB3,ARGB2>0, 
         clr   ARGB0
;  Ub=Up-Um*KK
CntUI01: sub   ULow,ARGB0
         sbc   UHi,ARGB1
;  KI
         mov   ARGB0,ARGD0
         mov   ARGB1,ARGD1
         ldi   COUNT1,5
         mov   ARGB4,COUNT1
         clr   ARGB5
         rcall MUL16        ; (5*KI)-->ARGB3...ARGB0
;  I
         mov   ARGB4,ADCILow; low NI
         mov   ARGB5,ADCIHi ; hi NI
         rcall MUL16        ; (5*KI*NI)-->ARGB3...ARGB0
         ldi   COUNT1,4
         mov   ARGB5,COUNT1
         rcall DL41         ; /4
         ldi   TMP1,RU      ;  RU
         rcall READEE
         cpi   TMP2,$FF
         brne  PC+2         ; RU < FF
         ldi   TMP2,100     ;   
         mov   ARGB5,TMP2   ; RU
CntUI04: rcall DL41         ; /RU
         mov   IHi,ARGB1    ;  I
         mov   ILow,ARGB0   ; /
         ret

; /  2-    2  2-10 
; :  ARGB1-ARGB0
; : ARGD4-ARGD0
;            
; : ARGB5-ARGB2,COUNT1,TMP1,TMP2,Z

TRN10:    ldi   TMP1,10     ; 
          mov   ARGB5,TMP1
          clr   ARGB2       ; .. 
          clr   ARGB3       ; /
          ldi   TMP2,5      ;  
          ldi   ZL,ADR_ARGD0;  ARGD0
          clc               ; C=0
TRN2:     rcall DL41
          st    Z,ARGB4
          dec   ZL
          dec   TMP2
          brne  TRN2
          ret

; /   
; : ARGD9-ARGD0
;            
; . COUNT1,TMP1,TMP2,Z

INDIC:    ldi   COUNT1,10     ; 10 
          ldi   ZL,ADR_ARGD9  ;  .  (ARGD9)
INDIC2:   ld    TMP1,Z
          swap  TMP1          ; . .   .
          ldi   TMP2,4        ;  
INDIC6:   rol   TMP1          ; .  -->C
          brcc  INDIC3        ; C=0
          sbi   PORTB,DI      ; DI=1
INDIC3:   brcs  INDIC4        ; C=1
          cbi   PORTB,DI      ; DI=0
INDIC4:   sbi   PORTB,SK      ; SK=1
          rjmp  PC+1          ; 
          rjmp  PC+1          ; /
          cbi   PORTB,SK      ; SK=0
          dec   TMP2
          brne  INDIC6        ; . 
          inc   ZL            ;  . 
          dec   COUNT1
          brne  INDIC2        ;  . 
          cbi   PORTB,DI
          ret
